#include "hmg.ch"
#include "hmg_GFilatov.ch"
#include "hmg_BoxLetterShow.ch"

  Function Main

*----------------------------------------*
* (c) Mustafa Lpez  mustalopez@gmail.com
*----------------------------------------*

  REQUEST DBFCDX , DBFFPT , DBFDBT
  RDDSETDEFAULT( "DBFCDX" )
  
*----------------------------------* 

  REQUEST HB_CODEPAGE_ESWIN     
  HB_SETCODEPAGE("ESWIN")    
 
  REQUEST HB_LANG_ES   
  HB_LANGSELECT("ES")  

*----------------------------------*
  SET CENTURY ON
  SET DATE FRENCH
  SET ESCAPE ON
  SET NAVIGATION EXTENDED
  SET LANGUAGE TO SPANISH 
  SET CODEPAGE TO SPANISH
  SET DELETED ON
  SET DATE FORMAT TO 'dd/mm/yyyy'
  SET BROWSESYNC ON
  SET INTERACTIVECLOSE OFF  
  SET TOOLTIPSTYLE BALLOON  
*----------------------------------* 

         DEFINE WINDOW Form_1              ;           
		AT 0,0                     ;
		WIDTH 992 HEIGHT 735       ;  
		TITLE "Demo - hmg_BoxLetterShow  * hmg_GFilatov.ch * 2018"   ;
                ICON 'Logo'                ; 
                NOSIZE TOPMOST NOMINIMIZE NOMAXIMIZE ;  
                MAIN                       ;
		FONT "Arial" SIZE 10 BACKCOLOR { 211,218,236 } ;
                ON INTERACTIVECLOSE {||.F., MsgStop('Not Allowed', 'Attention !!!') }
                ON KEY ESCAPE ACTION Form_1.Release 
 
*------------------------------------------------ Box Window  ---------------------------------------------------*
      DRAW PANEL IN WINDOW Form_1 AT 15,15 TO  690 ,970     // By Grigory Filatov     
*     DrawWindowBoxRaised( "Form_1" , 15,15, 690, 970 )    //  By Grigory Filatov Optional  
*------------------------------------------------ Box Green  ----------------------------------------------------*
      BoxBoxNoColor( 33 , 659 , 294 , 73, "uy02",.T.  )   
      Box(037, 664, 285, 065 ,"qu03", 023,101,012 )
      LetterShadowM(055,705 ,"55x" ,"66x",500, 58,"hmg_BoxLetterShow","Ms Sans Serif",15,.T.,.T., 000,000,000,255,205,033 )
*-----------------------------------------------------------------------------------------------------------------*
*------------------------------------------------  Cuadro Adorno Egipto ------------------------------------------*
      NewBoxShadow( 135, 689, 246, 196 ,"13hi" ,"14hi","15hi", .T. , .F. , .T., 016,000,100 , 128,126,255 )  
      Box( 136 , 690 , 235 , 185, "xhy16",253, 209, 209  )   // <-----   Box Undido ----> BORDER CLIENTEDGE     
*-----------------------------------------------------------------------------------------------------------------*

    DEFINE IMAGE ImagePhoto 
        ROW    148
        COL    702 
        WIDTH  212  
        HEIGHT 161    
        PICTURE 'Resource\Mustafa.jpg'  
        HELPID Nil
        VISIBLE .T.
        STRETCH .F.
        ACTION Nil
    END IMAGE

*----------------------------------------------  END Cuadro Adorno Egipto-----------------------------------------*
*-----------------------------------------------------------------------------------------------------------------*
     NewBoxShadow( 040, 040, 150, 080 ,"16ha" ,"17hb","18hc", .T. , .F. , .T., 016,000,100 , 128,126,255 )   
*-----------------------------------------------------------------------------------------------------------------*
     NewBoxShadow( 040, 228, 150, 080 ,"16hd" ,"17hie","18hif", .T. , .F. , .T., 016,000,100 , 128,126,255 )   
     BoxBoxNoColor( 040, 228 , 141 , 069, "17xhi",.T.  )   
*-----------------------------------------------------------------------------------------------------------------*
     Box(140, 110, 200, 058 ,"01q", 128,126,255 ) //<----------- Box   
*-----------------------------------------------------------------------------------------------------------------*
     Box(105, 420, 200, 001 ,"14q", 255,255,255 ) //<----------- Line  Horizontal  
     Box(165, 420, 200, 003 ,"15q", 255,255,255 ) //<----------- Line  Horizontal 
     Box(030, 485, 001, 200 ,"16q", 255,255,255 ) //<----------- Line  Vertical      
     Box(030, 545, 003, 200 ,"17q", 255,255,255 ) //<----------- Line  Vertical     
*-----------------------------------------------------------------------------------------------------------------*
     Line(220, 090, 250, 001 ,"18q",  {007 ,002 , 204} )  //<--- Line  Horizontal       
*-----------------------------------------------------------------------------------------------------------------*        
     BoxShadowL(250, 035, "19q" , SPACE(5)+"Hola, como estas ?"+SPACE(5), 13, GREEN , BLACK )
*-----------------------------------------------------------------------------------------------------------------*
     BoxShadowT(245, 235, 175, 058 ,"20q", BLUE,BLACK , 4 ) 
*-----------------------------------------------------------------------------------------------------------------*
     BoxShadow(250, 450, 175, 058 ,"21q" ,"22q", 128 ,126 , 255 )   
*-----------------------------------------------------------------------------------------------------------------*
     DRAW BOX IN WINDOW Form_1 AT 320,30 TO 410,255    //  By Grigory Filatov 
*    DrawWindowBoxIn( "Form_1", 320, 30, 410, 255 )    //  By Grigory Filatov Optional  
*-----------------------------------------------------------------------------------------------------------------*
     LetterShadowT(332, 045,"23q" , "La Casa de la Abuela" ,15 ,{009,148,255}  )  //BLUE )    
*-----------------------------------------------------------------------------------------------------------------*
     LetterShadow(368, 046 ,"24q" ,"25q","Hello World ...","Arial",25,.F.,.T., 000,000,000, 226,123,039 )  
*-----------------------------------------------------------------------------------------------------------------*
     MiFrame(340,275,156,048,"frame_01","", {007 ,002 , 204} ,{ 211,218,236 } ) // <----- No title
     LabelBox(352, 285, 200, 058 ,"26q",SPACE(1)+ DTOC(DATE())+SPACE(1) ,"Cooper Black",15,.T.,.T.,000,000,000 , 018,215,155 )    
     Rectangle(335,450,175,58,"27q",{ 007,002,204 } ,3,3,2)
*-----------------------------------------------------------------------------------------------------------------*
     MiFrame(350,720,187,058,"frame_02","Mi Frame", {007 ,002 , 204} ,{ 211,218,236 } )
     LabelBox( 367, 730 , 150, 020, "85q","Mustafa in Egypt 2005","Arial",12,.T.,.T., 000,000,000, 255,016,014  ) 
*-------------------------------------------- Box Grid ------------------------------------------------------------*
     NewBoxShadow( 443, 056, 665, 227 ,"29q" ,"30q","31q", .T. , .F. , .T., 016,000,100 , 128,126,255 )  
                     Form_1.Label_29q.Enabled := .F.     // <---- Necesario si ponemos MonthCalendar or Textbox or Grid
                     Form_1.Label_30q.Enabled := .F.     // <---- Necessary if we MonthCalendar or Textbox or Grid
                     Form_1.Label_31q.Enabled := .F.     // <---- Necessary if we MonthCalendar or Textbox  or Grid

    Box( 443 , 055 , 657 , 217, "32q", 160, 220, 160  )  // <---- Box Undido ----> BORDER CLIENTEDGE     
                     Form_1.Label_32q.Enabled := .F.
*-----------------------------------------------------------------------------------------------------------------*

    MiFrame( 455,800,089,41,"frame_03","Records", { 007 ,002 , 204 },{ 211,218,236 }   )  
  
     @ 468, 827 Label Label_2G     ;   
                width   050        ;
                height  027        ;  
                FONT "Arial"  SIZE 10 BOLD  ;
                FONTCOLOR { 000, 000, 000 } ;
                BACKCOLOR { 211,218,236 }   ;  
                VALUE ""  

     CLOSE DATABASES
*--------------------------------------------------- Color Barra Video Inversa -----------------------------------*
  _HMG_SYSDATA [ 348 ] := { 199,250,225 }    
  _HMG_SYSDATA [ 349 ] := { 007,071,041 }   
  _HMG_SYSDATA [ 350 ] := { 235,237,095 }   
  _HMG_SYSDATA [ 351 ] := { 069,015,135 }  
*-----------------------------------------------------------------------------------------------------------------*
      SELECT 1   
      USE STOCK
      dbgotop()
      mGrid(450, 063, 640, 203 ,"3","STOCK" ) 
*-----------------------------------------------------------------------------------------------------------------*
*---------------------------------------------------  Up-Down  ---------------------------------------------------*
*-----------------------------------------------------------------------------------------------------------------* 

   MiFrame( 514,785,127,41,"frame_04","Up-Down", { 007 ,002 , 204 },{ 211,218,236 }   )           
             
    DEFINE BUTTON But_01  
         ROW    520
         COL    793       
         WIDTH  028 
         HEIGHT 028 
         PICTURE "Resource/Imagen01.jpg"            
         TOOLTIP 'First'//'Primero'   
         ACTION ( dBGoTop() ,  Form_1.Grid_3.RecNo := STOCK->(RecNo()) ,PositionData()  )                                    
     END BUTTON

     DEFINE BUTTON But_02 
         ROW    520  
         COL    820
         WIDTH  028  
         HEIGHT 028  
         PICTURE "Resource/Imagen02.jpg"     
         TOOLTIP 'Previous'//'Anterior'  
         ACTION  ( dBSkip ( -1 ) ,Form_1.Grid_3.RecNo := STOCK->(RecNo()) ,PositionData() ) 
    END BUTTON
 
    DEFINE BUTTON But_03
         ROW    520  
         COL    848
         WIDTH  028  
         HEIGHT 028  
         PICTURE "Resource/Imagen03.jpg"
         TOOLTIP 'Next'//'Siguiente' 
         ACTION ( dBSkip (1) , if ( Eof() , DbGoBottom() , Nil ) ,  Form_1.Grid_3.RecNo := STOCK->(RecNo()) ,PositionData()  )    
    END BUTTON   

    DEFINE BUTTON But_04
         ROW    520 
         COL    875
         WIDTH  028  
         HEIGHT 028  
         PICTURE "Resource/Imagen04.jpg"   
         TOOLTIP 'Last'  //'Ultimo' 
         ACTION ( dBGoBottom() ,  Form_1.Grid_3.RecNo := STOCK->(RecNo()) ,PositionData()  )  
    END BUTTON     
*-----------------------------------------------------------------------------------------------------------------* 
*-----------------------------------------------------------------------------------------------------------------*

               @ 585,791 BUTTON Salir                   ;     
                         CAPTION 'Exit'                 ;  
                         PICTURE 'Resource\Exit.bmp'    ;                  
                         TOOLTIP 'Exit ...'             ; 
                         WIDTH 105 HEIGHT 55            ; 
                         ACTION  Form_1.Release

      Chane_Style()    // <------------- Hace Recuadro en Grid_3
      Reminguy()  
      PositionData()   

   END WINDOW
   
    SETWINDOWCURSOR ( Form_1.Salir.Handle, "Resource\SmoothHand.cur")  
 
    Form_1.Label_2G.SetFocus 
    Form_1.Grid_3.Refresh
    Form_1.Grid_3.SetFocus  
 
   CENTER WINDOW Form_1
   ACTIVATE WINDOW Form_1

Return Nil

*------------------------------------------------------------* 
FUNCTION Reminguy()   //  GRID_WIDTH_AUTOSIZE
*------------------------------------------------------------*
   FOR i = 1 TO GetProperty ("Form_1","Grid_3","ColumnCount")
       SetProperty ("Form_1","Grid_3","ColumnWIDTH", i, GRID_WIDTH_AUTOSIZE) 
   NEXT
Return   

*------------------------------------------------------------* 
FUNCTION Chane_Style()   // Hace Recuadro en Grid_3  
*------------------------------------------------------------* 
 HMG_ChangeWindowStyle ( GetControlHandle("Grid_3","Form_1"), LVS_REPORT, NIL, .T. )

Return

*------------------------------------------------------------* 
 FUNCTION PositionData()  // N de Registro / Total  
*------------------------------------------------------------*
 aReg    :=  Form_1.Grid_3.Value  
 nValor  :=  0
 Regs    :=  STR(  Form_1.Grid_3.ItemCount )  
 
   Select('STOCK')
   nValor := aReg[1] 
   Form_1.Label_2G.value := ALLTRIM(STR((nValor)))+SPACE(1)+"/"+SPACE(1)+ALLTRIM( Regs)  

Return 

*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*